#!/usr/bin/ruby
# coding: utf-8

#######################################
#
# Marcin Woźniak
# s434812
#
########################################

load '../module.rb'
require 'thread'
require 'thwait'

def returnRownanie(a,b,p)
  puts
  puts "Równanie krzywej jest równe: " + "Y^2 = X^3+" + a.inspect + "X+" + b.inspect + " mod "+ p.inspect
  puts
end

def delta(a,b,p)
  d = ((4 * betterExponentiation(a,3,p) % p) + (27 * betterExponentiation(b,2,p) % p)) % p
  return d
end

def rownanieKrzywej(a,b,p,x)
  fx = (betterExponentiation(x,3,p) + (a * x) % p + b % p) % p
  return fx
end

def generatorKrzywej(p)
  a = 0
  b = 0

  while true
    if primalityTest(p) &&  p % 4 == 3
      threads = []

      threads << Thread.new {
        a = SecureRandom.random_number(1..p-1)
      }

      threads << Thread.new {
        b = SecureRandom.random_number(1..p-1)
      }

      ThreadsWait.all_waits(*threads)

      if delta(a,b,p) != 0
        returnRownanie(a,b,p)
        return a,b
      end
    end
  end
end

def punktNaKrzywej(a,b,p)
   if delta(a,b,p) != 0
     while true
       x = SecureRandom.random_number(1..p-1)
       fx = rownanieKrzywej(a,b,p,x)
       if remSqEuler(fx,p)
         if a == 0
          y = 0
         elsif p == 2
          y = p
         elsif p % 4 == 3
          y = Math.sqrt(fx).to_i % p
          #y = betterExponentiation(a,(p+1/4),p)
         end
         return x,y
       end
     end
   end
end

def czyPunktNalezyDoKrzywej(a,b,p,x,y)
  fx = rownanieKrzywej(a,b,p,x)

  if fx == betterExponentiation(y,2,p)
    return true
  else
    return false
  end
end

def punktPrzeciwny(x,y)
  return x,-y
end

def sumaPunktow(a,b,p,x1,y1,x2,y2)
  # P + Q = R
  if (x1 != x2) && (y1 != y2)
    alpha = (((y2 - y1) % p) * reciprocal_Phi_p((x2 - x1),p)) % p
    x3 = (betterExponentiation(alpha,2,p) - (x1 % p) - (x2 % p)) % p 
    y3 = (alpha * (x1 - x3) - y1) % p
    return x3,y3
  end
  # P + -Q = 0 DZIALA
  if (x1 == x2) && (y1 == -y2)
    return "0"
  end
  # P + P = 2P DZIALA
  if (x1 == x2) && (y1 == y2)
    alpha = (((3 * betterExponentiation(x1,2,p) % p + a) % p) * reciprocal_Phi_p(2 * y1,p)) % p
    x3 = betterExponentiation(alpha,2,p) - (x1 % p) - (x2 % p)
    y3 = (alpha * (x1 - x3) - y1) % p
    return x3,y3
  end
  # 0 - element neutrany --> P + 0 = P
  if (x1 == 0 && y1 == 0 )
    return x2,y2
  elsif (x2 == 0 && y2 == 0)
    return x1,y1
  end
    
end

#puts generatorKrzywej(11).inspect
#puts punktNaKrzywej(2,7,11).inspect
#puts czyPunktNalezyDoKrzywej(2,7,11,7,1).inspect
#puts czyPunktNalezyDoKrzywej(2,7,11,2,2).inspect
#puts punktPrzeciwny(2,2).inspect
#puts sumaPunktow(2,2,17,5,1,5,1).inspect

##################################################
# Zadania z konca wykladu suma punktow
#
# Niech E/F7 będzie postaci
# E : Y^2 = X^3 + 1
#
# Niech P=(1,3)  Q=(2,4)  R=(6,0)
#
# Obliczyc:
# 1) -Q
# 2) R + [0,0]
# 3) P + Q
# 4) 2R
#
##################################################
# Rozwiązanie:
a = 0
b = 1
p = 7

xp = 1
yp = 3

xq = 2
yq = 4

xr = 6
yr = 0

puts punktPrzeciwny(2,4).inspect
puts sumaPunktow(a,b,p,xr,yr,0,0).inspect
puts sumaPunktow(a,b,p,xp,yp,xq,yq).inspect
puts sumaPunktow(a,b,p,xp,yp,xp,yp).inspect
##################################################
